petsc-3.6.2 2015-10-02
Report Typos and Errors

# MatDiagonalSet

Computes Y = Y + D, where D is a diagonal matrix that is represented as a vector. Or Y[i,i] = D[i] if InsertMode is INSERT_VALUES.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode  MatDiagonalSet(Mat Y,Vec D,InsertMode is)

### Input Parameters

| Y | - the input matrix
| D | - the diagonal matrix, represented as a vector
| i | - INSERT_VALUES or ADD_VALUES

Neighbor-wise Collective on Mat and Vec

Notes: If the matrix Y is missing some diagonal entries this routine can be very slow. To make it fast one should initially fill the matrix so that all diagonal entries have a value (with a value of zero for those locations that would not have an entry).

### Keywords

matrix, add, shift, diagonal

### See Also

MatShift()

Level:intermediate
Location:src/mat/utils/axpy.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/tao/pde_constrained/examples/tutorials/elliptic.c.html